﻿#region License
/* NBit Bit Manipulation Library
   Copyright 2012 Illusory Studios LLC <james@illusorystudios.com>

   This software is provided 'as-is', without any express or implied
   warranty. In no event will the authors be held liable for any damages
   arising from the use of this software.
 
   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must
   not claim that you wrote the original software. If you use this software
   in a product, an acknowledgement in the product documentation would be
   appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must
   not be misrepresented as being the original software.

   3. This notice may not be removed or altered from any source
   distribution. 
*/
#endregion

namespace NBit
{
    class CrcMsb : Crc
    {
        int _bits; uint _polynomial;

        public CrcMsb(int bits, uint polynomial, uint preset, uint postinvert)
            : base(preset, postinvert)
        {
            _bits = bits; _polynomial = polynomial << (32 - bits);
        }

        internal override uint NextBits(uint crc, uint @byte, int bits)
        {
            var polynomial = _polynomial; var crcSize = _bits;

            if (bits < 32) { @byte &= (1u << bits) - 1; }
            crc <<= 32 - crcSize; crc ^= @byte << (32 - bits);

            for (int i = 0; i < bits; i++)
            {
                if (0 != (crc >> 31))
                {
                    crc <<= 1; crc ^= polynomial;
                }
                else
                {
                    crc <<= 1;
                }
            }

            return crc >> (32 - crcSize);
        }
    }
}
